<template>
	<view class="content">
		<view class="row b-b">
			<text class="tit">联系人</text>
			<input class="input" type="text" v-model="addressData.name" placeholder="收货人姓名" placeholder-class="placeholder" />
		</view>
		<view class="row b-b">
			<text class="tit">手机号</text>
			<input class="input" type="number" v-model="addressData.mobile" placeholder="收货人手机号码" placeholder-class="placeholder" />
		</view>
		<view class="row b-b">
			<text class="tit">省市区</text>
			<picker mode="multiSelector" :range="areaJs" range-key="name" :value="addressIndex" @columnchange="onCityClick" @change="changeArea">
				<view v-if="addressDetail">{{ addressDetail }}</view>
				<view v-else class="font-color-gray">请选择省市区</view>
			</picker>
		</view>
		<view class="row b-b">
			<text class="tit">村镇</text>
			<picker mode="multiSelector" :range="cityJs" range-key="name" :value="addressIndexCity" @columnchange="onCityChange" @change="changeCity">
				<view v-if="addressDetailCity">{{ addressDetailCity }}</view>
				<view v-else class="font-color-gray">请选择村镇</view>
			</picker>
		</view>
		<view class="row b-b">
			<text class="tit">门牌号</text>
			<input class="input" type="text" v-model="addressData.area" placeholder="楼号、门牌" placeholder-class="placeholder" />
		</view>
		<uni-list class="margin-t-20">
			<uni-list-item
				title="设为默认"
				:switch-checked="addressData.default"
				:show-switch="true"
				:show-arrow="false"
				switch-color="#5dbc7c"
				@switchChange="switchChange"
			></uni-list-item>
		</uni-list>

		<button class="add-btn" @click="confirm">提交</button>
	</view>
</template>

<script>
import uniList from '@/components/uni-list/uni-list.vue';
import uniListItem from '@/components/uni-list-item/uni-list-item.vue';
import uniPopup from '@/components/uni-popup/uni-popup.vue';
import { addressEdit } from '@/api/user.js';
import { getAddressArea, getAddressCity } from '@/api/set.js';
import { mapState, mapMutations } from 'vuex';
export default {
	components: {
		uniList,
		uniListItem,
		uniPopup
	},
	data() {
		return {
			addressIndex: [0, 0, 0], //当前选中的省市区
			addressIndexCity: [0, 0], //当前选中的村镇
			addressDetail: '', //省市区名称
			addressDetailCity: '', //村镇名称
			addressData: {
				name: '',
				mobile: '',
				address: {
					province: '',
					city: '',
					district: ''
				},
				area: '',
				default: false
			}
		};
	},
	computed: {
		...mapState('address', ['area', 'city']),
		// 省市区动态渲染列表
		areaJs() {
			if (this.area.length > 0) {
				const index1 = this.addressIndex[0];
				return [this.area, this.area[index1].child, this.area[index1].child[this.addressIndex[1]].child];
			}
		},
		// 村镇切换渲染
		cityJs() {
			if (this.city.length > 0) {
				const index1 = this.addressIndexCity[0];
				return [this.city, this.city[index1].child];
			}
		}
	},
	onLoad(option) {
		let title = '新增收货地址';
		if (option.type === 'edit') {
			title = '编辑收货地址';
			let data = JSON.parse(option.data);
			console.log(data);
			this.addressData = {
				name: data.real_name,
				mobile: data.phone,
				address: {
					province: data.province,
					city: data.city,
					district: data.district
				},
				area: data.detail,
				default: data.is_default == 1,
				id: data.id
			};
			this.addressDetail = data.province + data.city + data.district;
		}
		this.manageType = option.type;
		uni.setNavigationBarTitle({
			title
		});
		this.init();
	},
	methods: {
		...mapMutations('address', ['setArea', 'setCity']),
		// 初始化
		init() {
			if (this.area.length <= 0) {
				// 获取省市区信息
				this.getAddressArea();
			}
		},
		// 获取省市区信息
		getAddressArea() {
			getAddressArea().then(e => {
				this.setArea(e.data);
				this.getAddressCity(e.data[0].child[0].child[0].city_id);
			});
		},
		// 获取村镇信息
		getAddressCity(id) {
			uni.showLoading({
				title: '村镇数据加载中....',
				mask: true
			});
			getAddressCity({}, id)
				.then(e => {
					uni.hideLoading();
					this.setCity(e.data);
				})
				.catch(e => {
					uni.hideLoading();
					uni.showToast({
						title: ''
					});
				});
		},
		//省市区确认后村镇数据更新
		changeArea(e) {
			if (this.area.length > 0) {
				const index0 = this.addressIndex[0];
				const index1 = this.addressIndex[1];
				const index2 = this.addressIndex[2];
				this.addressDetail = this.areaJs[0][index0].name + this.areaJs[1][index1].name + this.areaJs[2][index2].name;
				this.getAddressCity(this.areaJs[2][index2].city_id);
			} else {
				this.addressDetail = '';
			}
		},
		// 村镇切换
		changeCity(e) {
			if (this.area.length > 0) {
				const index0 = this.addressIndexCity[0];
				const index1 = this.addressIndexCity[1];
				this.addressDetailCity = this.cityJs[0][index0].name + this.cityJs[1][index1].name;
			} else {
				this.addressDetailCity = '';
			}
		},
		// 选中省市区切换
		onCityClick(data) {
			// 采用map防止直接修改无法触发数组set事件
			this.addressIndex = this.addressIndex.map((e, ind) => {
				if (data.detail.column < ind) {
					e = 0;
				}
				if (ind == data.detail.column) {
					e = data.detail.value;
				}
				return e;
			});
		},
		// 选中村镇切换
		onCityChange(data) {
			// 采用map防止直接修改无法触发数组set事件
			this.addressIndexCity = this.addressIndexCity.map((e, ind) => {
				if (data.detail.column < ind) {
					e = 0;
				}
				if (ind == data.detail.column) {
					e = data.detail.value;
				}
				return e;
			});
		},
		//地图选择地址
		chooseLocation() {
			uni.chooseLocation({
				success: data => {
					console.log(data);
					this.addressData.addressName = data.name;
					this.addressData.address = data.name;
				}
			});
		},
		// 设置是否为默认地址
		switchChange(e) {
			this.addressData.default = e.value;
		},
		//提交
		confirm() {
			let obj = this;
			let data = this.addressData;
			if (!data.name) {
				this.$api.msg('请填写收货人姓名');
				return;
			}
			if (!/(^1[3|4|5|7|8][0-9]{9}$)/.test(data.mobile)) {
				this.$api.msg('请输入正确的手机号码');
				return;
			}
			if (!data.address) {
				this.$api.msg('请在地图选择所在位置');
				return;
			}
			if (!data.area) {
				this.$api.msg('请填写门牌号信息');
				return;
			}

			//this.$api.prePage()获取上一页实例，可直接调用上页所有数据和方法，在App.vue定义
			addressEdit({
				real_name: data.name,
				phone: data.mobile,
				address: {
					province: data.address.province,
					city: data.address.city,
					district: data.address.district
				},
				detail: data.area,
				is_default: data.default,
				id: data.id || '',
				type: 1
			}).then(function(e) {
				obj.$api.prePage().refreshList();
				uni.showToast({
					title: '提交成功',
					duration: 2000
				});
				setTimeout(function() {
					uni.navigateBack();
				}, 800);
			});
		}
	}
};
</script>

<style lang="scss">
page {
	background: $page-color-base;
	padding-top: 16rpx;
}

.row {
	display: flex;
	align-items: center;
	position: relative;
	padding: 0 30rpx;
	height: 110rpx;
	background: #fff;

	.tit {
		flex-shrink: 0;
		width: 120rpx;
		font-size: 30rpx;
		color: $font-color-dark;
	}
	.input {
		flex: 1;
		font-size: 30rpx;
		color: $font-color-dark;
	}
	.iconlocation {
		font-size: 36rpx;
		color: $font-color-light;
	}
}
.default-row {
	margin-top: 16rpx;
	.tit {
		flex: 1;
	}
	switch {
		transform: translateX(16rpx) scale(0.9);
	}
}
.add-btn {
	display: flex;
	align-items: center;
	justify-content: center;
	width: 690rpx;
	height: 80rpx;
	margin: 60rpx auto;
	font-size: $font-lg;
	color: #fff;
	background-color: $base-color;
	border-radius: 10rpx;
	// box-shadow: 1px 2px 5px rgba(219, 63, 96, 0.4);
}

.alert-box {
	background-color: #ffffff;
}
</style>
